public class ListIterator {
	private LinkedList list;
	private Node current;
	private Node previous;
	private Node next;
	
	public ListIterator(LinkedList list) {
		this.list = list;
		
		current  = null;
		previous = null;
		next     = list.first;
	}

	public boolean hasNext() {
		return (next != null);
	}
	
	public Object next() {
		previous = current;
		current  = next;
		next     = current.next;
		
		return current.element;
	}
	
	public void add(Object o) {
		if (current != null) {
			Node node = new Node();
			node.element = o;
			node.next    = current;

			if (previous == null) {
				list.first = node;
				if (list.last == null)
					list.last = node;
			} else {
				previous.next = node;
			}
			previous = node;
		}
	}
	
	public void remove() {
		// The implementation of this method is left as an exercise.
		
		// It should remove the current element from the iterator.
		// To start with, draw a diagram about how the chain of nodes
		// looks like. Then imagine that you remove an element.
		// Which references needs to be changed? 
		// Think about the three scenarious, the element to be removed
		// is either the first, the last or somewhere in the middle.
		// You should think about the three cases and do the right
		// updates in each case. After you get a satisfactory solution,
		// implement it and test it.
	}
}

